/* device driver for pc26at a2d card */
#include <linux/ioctl.h>
#include "gpib_driver.h"
#ifndef GPIB_MAJOR
#define GPIB_MAJOR 0
#endif

#define BOOL int
#define TRUE 	1
#define FALSE	0
/* following are the factory defaults for the GPIB */
/* They are all acceptable for webface- matt aug 2001*/
#define GPIB_BASE_ADDRESS	0x02e1	/* Other legal addresses = 0x22e1 0x42e1 0x62e1 */
#define GPIB_DEVICE_NUMBER	21	/* this is the address on the GPIB bus that the
					   card uses to refer to itself, 21 is a traditional
					   choice- don't know why- matt sept 2001 */
/*#define GPIB_IRQ		5*//* not sure if card does interrupts*/

#define GPIB_MOD_NAME		"gpib"

/* ioctl numbers */
#define MAGIC		101
/* make it possible to remove the module if crashed */
#define GPIB_HARDRESET	_IO(MAGIC,0)

/* a universal mutex giving status */
/* the offset allows the device number to be returned in a byte */
#define OFFSET 		32
#define GPIB_IDLE		0*OFFSET
#define GPIB_WAIT_BUS		1*OFFSET
#define GPIB_WAIT_DEV_WRITE	2*OFFSET
#define GPIB_WAIT_DEV_READ	3*OFFSET
#define GPIB_NO_DEV		-1

#define GPIB_CONTROLLER_MASK	128
#define GPIB_BOARD_MASK 	64+32

#define GPIB_NEXT_EOF			1
#define GPIB_NEXT_REMAINING_BYTES	2
#define GPIB_IO_ERROR			3

typedef struct gpd {
	int next;
	int minor;
	BOOL controller;
	int device_number;
	int speed; /* expected number of polls per byte */
	int buff_size;
	char * buffer;
	} gpd_t;

/* include the low level driver routines */
#include "gpib_driver.c"	
