#include <stdlib.h>
#include "gpib_usr.h"
extern int GPIB_board_gpib_address;
extern GPIB_baseaddress GPIB_IO_base_address;

int GPIB_devclear (char address){
	if(GPIB_config_to_send(address)==GPIB_ERROR)
		return GPIB_ERROR;
	return GPIB_sendcommand (GPIB_SDC_CMD);
	}

int GPIB_clear_all(void){
	return GPIB_sendcommand(GPIB_DCL_CMD);
	}

// Enable devices front panel
int GPIB_enablelocal (char address){
	if(GPIB_config_to_send(address)==GPIB_ERROR)
		return GPIB_ERROR;
	// Send Go To Local command to selected devices 
	return GPIB_sendcommand (GPIB_GTL_CMD);
	}

// Enable devices front panel
int GPIB_enableremote (char address){
	// Assert REN Line 
	if(address>MAX_ADDRESS)
		return GPIB_ERROR;
        if(GPIB_config_to_send(address)==GPIB_ERROR)
		return GPIB_ERROR;
	GPIB_pause();
	return GPIB_RENLine (TRUE);
	}


int GPIB_receive (char address, char *buff, int N){
	// receive setup code goes here....
	if(GPIB_config_to_receive(address)==GPIB_ERROR){
		return GPIB_ERROR;
		}
	// idiot checking
	if (buff==NULL || N<0){
                return GPIB_ERROR;
		}
	return GPIB_readdata (buff, N);
	}

int GPIB_config_to_receive(char address){
	// idiot check
        if(address>MAX_ADDRESS)
                return GPIB_ERROR;
	// set unlisten....
        if(GPIB_sendcommand(GPIB_UNL_CMD)==GPIB_ERROR)
                return GPIB_ERROR;
	// set ther board to listen
        if(GPIB_sendcommand(GPIB_MLA_CMD+GPIB_board_gpib_address)==GPIB_ERROR)
                return GPIB_ERROR;
	// set the device to talk
        if(GPIB_sendcommand(GPIB_MTA_CMD+address)==GPIB_ERROR)
                return GPIB_ERROR;
        if (GPIB_standby()!=GPIB_OK)
                return GPIB_ERROR;
        return 1;
	}

int GPIB_config_to_send(char address){
	// idiot check
        if(address>MAX_ADDRESS)
                return GPIB_ERROR;
	// set the board to talk
        if(GPIB_sendcommand(GPIB_MTA_CMD+GPIB_board_gpib_address)==GPIB_ERROR)
                return GPIB_ERROR;
	// set unlisten....
        if(GPIB_sendcommand(GPIB_UNL_CMD)==GPIB_ERROR)
                return GPIB_ERROR;
	// set the device to listen
        if(GPIB_sendcommand(GPIB_MLA_CMD+address)==GPIB_ERROR)
		return GPIB_ERROR;
	return 1;
	}

int GPIB_send (char address, char *buff, int N){
        if(GPIB_enableremote(address)==GPIB_ERROR)
		return GPIB_ERROR;
	return GPIB_writedata (buff, N);
	}


int GPIB_send_local_lock_out (void){
	GPIB_RENLine (TRUE);
	return GPIB_sendcommand(GPIB_LLO_CMD);
	}




